(define-module (ordo context)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-9)
  #:use-module (srfi srfi-26)
  #:export (context
            context?
            context-scratch-dir
            add-context-triggers!
            get-context-triggers
            context-triggered?
            register-context-var!
            context-ref
            resolve-context-ref
            resolve-context-refs))

(define-record-type <context>
  (make-context scratch-dir vars)
  context?
  (scratch-dir context-scratch-dir set-context-scratch-dir!)
  (vars context-vars set-context-vars!)
  (triggers context-triggers set-context-triggers!))

(define* (context #:key scratch-dir init-vars)
  (make-context scratch-dir init-vars))

(define-record-type <context-ref>
  (context-ref name)
  context-ref?
  (name var-name))

(define (resolve-context-ref ctx v)
  (if (context-ref? v)
      (assoc-ref (context-vars ctx) (var-name v))
      v))

(define (resolve-context-refs ctx args)
  (map (cut resolve-context-ref ctx <>) args))

(define (add-context-triggers! ctx triggers)
  (when triggers
    (set-context-triggers! ctx
                           (apply lset-adjoin equal? (or (context-triggers ctx) '()) triggers))))

(define (context-triggered? ctx trigger)
  (find (lambda (t) (equal? t trigger)) (context-triggers ctx)))

(define (register-context-var! ctx var-name val)
  (set-context-vars! ctx (assoc-set! (context-vars ctx) var-name val)))
