(define-module (ordo handler)
  #:use-module (ice-9 match)
  #:use-module (srfi srfi-1) ; list utils
  #:use-module (srfi srfi-9) ; records
  #:use-module (srfi srfi-26) ; cut
  #:use-module (ordo context)
  #:export (handler
            handler?
            handler-description
            handler-action
            run-handler))

(define-record-type <handler>
  (make-handler description action)
  handler?
  (description handler-description)
  (action handler-action))

(define* (handler description action)
  (make-handler description action))

(define (run-handler conn ctx handler)
  (match handler
    (($ <handler> description action)
     (format #t "RUNNING HANDLER ~a~%" description)
     (action conn ctx))))
