(define-module (ordo task)
  #:use-module (ice-9 match)
  #:use-module (srfi srfi-1) ; list utils
  #:use-module (srfi srfi-9) ; records
  #:use-module (srfi srfi-26) ; cut
  #:use-module (ordo context)
  #:export (task
            task?
            task-description
            task-action
            task-register
            task-triggers
            run-task))

(define-record-type <task>
  (make-task description action register triggers)
  task?
  (description task-description)
  (action task-action)
  (register task-register)
  (triggers task-triggers))

(define* (task% description action #:key (register #f) (triggers '()))
  (make-task description action register triggers))

(define-syntax task
  (syntax-rules ()
    ((_ description (action arg ...) kwarg ...)
     (task%
      description
      (lambda (conn ctx)
        (action conn ctx (assoc-ref ctx arg) ...))
      kwarg ...))))

(define (run-task conn ctx task)
  (match task
    (($ <task> description action register triggers)
     (format #t "RUNNING TASK ~a~%" description)
     (let ((result (action conn ctx)))
       (when register
         (register-context-var! ctx register result))
       (when triggers
         (add-context-triggers! ctx triggers))))))
